// MoI Nodeedit v.0.6 - Max Smirnov, 2016
// litegraph.js library (c) Javi Agenjo http://tamats.com
// Object2 nodes Karsten Marquas

(function () {
    // ######### Get selected objects  ##########
function SelectedObjExt()
{
	this.addOutput("","objectlist");
	this.inputobjects = moi.geometryDatabase.createObjectList();
	this.clones = moi.geometryDatabase.getObjects();
	
    this.properties = { order:["By Selection", "By Selection", "By Creation"] };
	this.origSelobjects = moi.geometryDatabase.createObjectList();
	
}

SelectedObjExt.title = "SelectedExt";
SelectedObjExt.desc = "Selected objects Ext";

SelectedObjExt.prototype.onAdded = function() 
{
	var allobjects = moi.geometryDatabase.getObjects();
	var createdObjs = this.graph.getCreatedObjects();
	
	this.origSelobjects = moi.geometryDatabase.createObjectList();
	
	for ( var o = 0; o < allobjects.length; o++ ) {
		var obj = allobjects.item(o);
		if ( obj.selected && obj.displayMode === 0 && !obj.hidden && createdObjs.indexOf(obj.id)<0 ) {
			this.inputobjects.addObject(obj);
			this.origSelobjects.addObject(obj);
		}
	}
	
	if (this.properties.order[0] == "By Selection") {
		this.inputobjects.sortBySelectionOrder();
	}
	
	this.inputobjects.setProperty( 'selected',0);
	this.inputobjects.setProperty( 'displayMode',1);
	if (this.graph.status > 1 && !this.selected ) this.inputobjects.setProperty( 'hidden', true);
	this.outputs[0].label = "("+this.inputobjects.length+")";
	this.clones = moi.geometryDatabase.createObjectList();
	for ( var o = 0; o < this.inputobjects.length; o++ ) { this.clones.addObject(this.inputobjects.item(o).clone()); this.clones.item(o).styleIndex = this.inputobjects.item(o).styleIndex; }
	this.computeSize();
}

SelectedObjExt.prototype.onPropertyChange = function() 
{
	this.inputobjects = moi.geometryDatabase.createObjectList();
	for ( var o = 0; o < this.origSelobjects.length; o++ ) {
		this.inputobjects.addObject(this.origSelobjects.item(o));
	}
	
	if (this.properties.order[0] == "By Selection") {
		this.inputobjects.sortBySelectionOrder();
	}	
	this.clones = moi.geometryDatabase.createObjectList();
	for ( var o = 0; o < this.inputobjects.length; o++ ) { this.clones.addObject(this.inputobjects.item(o).clone()); this.clones.item(o).styleIndex = this.inputobjects.item(o).styleIndex; }
}

SelectedObjExt.prototype.getExtraMenuOptions = function(graphcanvas) {var that = this, thatgraph = this.graph;  return [{content:lang.getTranslation("Update"), callback: function() { that.onClear(); that.onAdded(); thatgraph.setisChangedFlag(that.id);}}, { content:lang.getTranslation("Clear"), callback: function() { that.onClear(); thatgraph.setisChangedFlag(that.id);}}]; }
SelectedObjExt.prototype.onClear = function() { this.onRemoved(); this.inputobjects = moi.geometryDatabase.createObjectList(); this.outputs[0].label = this.inputobjects.length; this.clones = moi.geometryDatabase.createObjectList();}
SelectedObjExt.prototype.onRemoved = function() { this.inputobjects.setProperty( 'displayMode',0); this.inputobjects.setProperty( 'hidden', false);  this.inputobjects.setProperty( 'selected',1);}
SelectedObjExt.prototype.onStart = function() { if (!this.selected) this.inputobjects.setProperty( 'hidden',true); }
SelectedObjExt.prototype.onStop = function() { this.inputobjects.setProperty( 'hidden', false); }
SelectedObjExt.prototype.onSelected = function() { this.inputobjects.setProperty( 'hidden', false); }
SelectedObjExt.prototype.onDeselected = function() { if (this.graph.status > 1) this.inputobjects.setProperty( 'hidden',true); }
SelectedObjExt.prototype.onExecute = function()
{
	this.setOutputData(0, this.clones);
}
SelectedObjExt.prototype.onApply = function() {}
SelectedObjExt.prototype.onDrawBackground = function(ctx) {}

LiteGraph.registerNodeType("Objects2/SelectedExt", SelectedObjExt);
//BrepNameSubObjects
// The node copies the BRep-input, select the edges of the copy, name them and gives it to the
// output of the node and a copy to the moi.GeometryDatabase. The copy in the 
// moi.GeometryDatabase is selectable, so you can select them for creating other
// nodes based on the selection
    function nameSubObjects()
    {
        this.addInput("B-Rep", "objectlist");
        this.addOutput("Out", "objectlist");
        this.properties = {BRepName: '', visible: ["On", "On", "Off"]};
        this.tempObjects = moi.geometryDatabase.createObjectList();
    }
    nameSubObjects.title = "BrepNameSubObjects";
    nameSubObjects.desc = "BrepNameSubObjects";
    nameSubObjects.prototype.onAdded = function ()
    {
        this.tempstyle = moi.geometryDatabase.findStyle('tempstyle', true);
        this.tempstyle.color = (160) << 16 | (220) << 8 | (240);
        if (this.properties.BRepName == '') {
            this.properties.BRepName = getUID(6);
        }
    }
    nameSubObjects.prototype.onExecute = function ()
    {
        moi.geometryDatabase.removeObjects(this.tempObjects); // clear from old faces from a previous run
        this.tempObjects = moi.geometryDatabase.createObjectList(); //reset of the tempObjectsList

        var inBRep = this.getInputData(0, moi.geometryDatabase.createObjectList());

        if (inBRep.length > 0)
        {
            inBRep.item(0).name = this.properties.BRepName;

            var inBrepEdges = inBRep.item(0).getEdges();
            var inBrepFaces = inBRep.item(0).getFaces();
            for (var i = 0; i < inBrepEdges.length; i++)
            {
                inBrepEdges.item(i).name = this.properties.BRepName + "_E" + i;
            }
            for (var j = 0; j < inBrepFaces.length; j++)
            {
                inBrepFaces.item(j).name = this.properties.BRepName + "_F" + j;
            }
            var originXYZ = moi.VectorMath.createPoint(0, 0, 0); //Helppoint for a identical copy
            this.tempObjects = factory('copy',inBRep,originXYZ,originXYZ,true);
            moi.geometryDatabase.addObjects(this.tempObjects); // thowing the polyfaces to the database, so they are selectable!!!
            this.tempObjects.item(0).styleIndex = this.tempstyle.index;
            if (this.properties.visible[0] === "Off")
                for (var i = 0; i < this.tempObjects.length; i++)
                {
                    this.tempObjects.item(i).hidden = true;
                }
            this.setOutputData(0, inBRep);
        }

    }
    nameSubObjects.prototype.onApply = function ()
    {
        moi.geometryDatabase.removeObjects(this.tempObjects); // clear selectable Objects from a previous run
    }
    LiteGraph.registerNodeType("Objects2/NameSubObjs", nameSubObjects);
    
    function extract()
    {
        this.size = [60, 20];
        this.addInput("Brep", "objectlist");
        this.addOutput("Out1", "objectlist");
        this.properties = {objName: '',};
        this.internal = {extractedObjNames: [0]};
        this.selectedObjs = moi.geometryDatabase.createObjectList();
        this.namesOK = false;
    }

    extract.title = "Extract";
    extract.desc = "Extract";
    extract.prototype.setValue = function (v)
    {
        if (typeof (v) == "string")
            this.properties.objName = v;
        this.properties.objName = v;
        this.setDirtyCanvas(true);
    }
    
    extract.prototype.getExtraMenuOptions = function() {var that = this, thatgraph = this.graph;  return [{content:lang.getTranslation("Update"), callback: function() { that.onUpdate();thatgraph.setisChangedFlag(that.id);}}];};

     extract.prototype.onUpdate = function () //reselection of the faces for the bridge
     {
     this.internal.extractedObjNames=[0];
     this.onAdded();
     this.onExecute();
     }
    extract.prototype.onPropertyChange = function ()
    {

    }
    extract.prototype.onAdded = function ()
    {
        this.selectedObjs = moi.geometryDatabase.createObjectList();
        this.selectedObjs = moi.geometryDatabase.getSelectedObjects(); // stores the selected faces (2 Faces as start and end of the loft)
        if (this.selectedObjs.length > 0)
        {
            for (var i = 0; i < this.selectedObjs.length; i++)
            {
                if (this.selectedObjs.item(i).name !== '')
                {
                    this.internal.extractedObjNames.push(this.selectedObjs.item(i).name); //storing the names of the selected objects
                    this.namesOK = true;
                } else
                {
                    this.namesOK = false;
                    return this.namesOK;
                }
            }
        }
//                moi.UI.alert(this.properties.filletEdgeNames.length, "selected filletedges");
    }

    extract.prototype.onApply = function ()
    {

    }

    extract.prototype.onExecute = function ()
    {
        var input = moi.geometryDatabase.createObjectList();
        input = this.getInputData(0, moi.geometryDatabase.createObjectList());
        var tempList = moi.geometryDatabase.createObjectList();
//                    moi.UI.alert(this.internal.extractedObjNames.length, "names length");
        if (input.length > 0)
        {
            for (var i = 0; i < this.internal.extractedObjNames.length; i++)
            {
                for (var j = 0; j < input.length; j++)
                {   var brepEdges = input.item(j).getEdges();
                    var brepFaces = input.item(j).getFaces();
                        for (var k = 0; k < brepEdges.length; k++){
                           if (brepEdges.item(k).name == this.internal.extractedObjNames[i])
                           tempList.addObject(brepEdges.item(k));   
                        }
                        for (var l = 0; l < brepFaces.length; l++){
                           if (brepFaces.item(l).name == this.internal.extractedObjNames[i])
                           tempList.addObject(brepFaces.item(l));   
                        }
                }
            }
        }

        var originXYZ = moi.VectorMath.createPoint(0, 0, 0); //Helppoint for a identical copy
        var out=factory('copy',tempList,originXYZ,originXYZ,true);
        this.setOutputData(0, out);
    }

    extract.prototype.onApply = function ()
    {

    }

    extract.prototype.onDrawBackground = function (ctx)
    {
//        this.inputs[0].label = this.properties.edge0;
//        this.inputs[1].label = this.properties.radius;
    }
    LiteGraph.registerNodeType("Objects2/Extract", extract);
// Point
    function ScaleUVW()
    {
        this.addInput("Object", "objectlist");
        this.addInput("Point", "pointarray");
        this.addInput("U", "numarray");
        this.addInput("V", "numarray");
        this.addInput("W", "numarray");

        this.addOutput("Object", "objectlist");
        this.properties = {mode: ["Long", "Long", "Short", "Average"], u: [1], v: [1], w: [1]};
    }

    ScaleUVW.title = "ScaleUVW";
    ScaleUVW.desc = "ScaleUVW";

    ScaleUVW.prototype.onExecute = function ()
    {
        var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, null, this.properties.u, this.properties.v, this.properties.w);
        this.properties.u = data.inputs[2];
        this.properties.v = data.inputs[3];
        this.properties.w = data.inputs[4];
        this.setOutputData(0, data.outputs[0]);

    }

    ScaleUVW.prototype.multiProcess = function (obj, frame, u, v, w)
    {
        var inframe = frame.getFrame();
        var out = [];
        var scalePt_u = moi.VectorMath.createPoint(inframe.xaxis.x + inframe.origin.x,
                inframe.xaxis.y + inframe.origin.y,
                inframe.xaxis.z + inframe.origin.z);
        var scalePt_v = moi.VectorMath.createPoint(inframe.yaxis.x + inframe.origin.x,
                inframe.yaxis.y + inframe.origin.y,
                inframe.yaxis.z + inframe.origin.z);
        var scalePt_w = moi.VectorMath.createPoint(inframe.zaxis.x + inframe.origin.x,
                inframe.zaxis.y + inframe.origin.y,
                inframe.zaxis.z + inframe.origin.z);
        var us = factory('scale1d', obj, inframe.origin, u, scalePt_u, null, true);
        var vs = factory('scale1d', us, inframe.origin, v, scalePt_v, null, true);
        out[0] = factory('scale1d', vs, inframe.origin, w, scalePt_w, null, true);

        return out;
    }

    LiteGraph.registerNodeType("Objects2/ScaleUVW", ScaleUVW);
// randomObj
    function randomObj()
    {
        this.addInput("In", "objectlist");
        this.addInput("n", "numarray");
        this.addOutput("Out", "objectlist");
        this.properties = {n: [12]};
    }

    randomObj.title = "randomObj";
    randomObj.desc = "randomObj";

    randomObj.prototype.onExecute = function ()
    {
        var inObj = this.getInputData(0, moi.geometryDatabase.createObjectList());
        this.properties.n = this.getInputData(1, this.properties.n);
        var output = moi.geometryDatabase.createObjectList();
        if (inObj.length > 1) {
            for (var i = 0; i < this.properties.n; i++)
                output.addObject(inObj.item(Math.floor((Math.random() * (inObj.length)))));
        }
        this.setOutputData(0, output);
    }

    LiteGraph.registerNodeType("Objects2/randomObj", randomObj);
// Concat
    function Concat2()
    {
        this.labels = "abcdef";
        this.size = [60, 20];
//        this.dynamicInternal = ["a", "b", "c", "d", "e", "f"];
        this.internal = {a: [], b: []};
//        this.addOutput("Out", "numarray");
        this.zero=[0];
    }

    Concat2.title = "Concat2";
    Concat2.desc = "Concat numarrays";

    Concat2.prototype.getExtraMenuOptions = function ()
    {
        var that = this;
        return [
            {content: lang.getTranslation("Numbers"), callback: function () {
                    if (that.inputs[0].type !== "numarray") {
                        var n = that.inputs.length;
                        for (var i = that.inputs.length - 1; i >= 0; i--)
                            that.removeInput(i, "");
                        for (var i = 0; i < n; i++)
                            that.addInput("Num", "numarray");
                        that.removeOutput(0, "");
                        that.addOutput("Out", "numarray");
                    }
                }},
            {content: lang.getTranslation("Points"), callback: function () {
                    if (that.inputs[0].type !== "pointarray") {
                        var n = that.inputs.length;
                        for (var i = that.inputs.length - 1; i >= 0; i--)
                            that.removeInput(i, "");
                        for (var i = 0; i < n; i++)
                            that.addInput("Pts", "pointarray");
                        that.removeOutput(0, "");
                        that.addOutput("Out", "pointarray");
                    }
                }},
            {content: lang.getTranslation("Objects"), callback: function () {
                    if (that.inputs[0].type !== "objectlist") {
                        var n = that.inputs.length;
                        for (var i = that.inputs.length - 1; i >= 0; i--)
                            that.removeInput(i, "");
                        for (var i = 0; i < n; i++)
                            that.addInput("Obj", "objectlist");
                        that.removeOutput(0, "");
                        that.addOutput("Out", "objectlist");
                    }
                }}
        ];
    }

    Concat2.prototype.onGetInputs = function ()
    {var inpName="";
        var list = [];
        if(this.inputs[0].type==="numarray") inpName="Num";
        if(this.inputs[0].type==="pointarray") inpName="Pts";
        if(this.inputs[0].type==="objectlist") inpName="Obj";

        list.push([inpName, this.inputs[0].type, {locked: true}]);

        return list;
    }

    Concat2.prototype.onInputAdded = function (inp)
    {
        this.internal[inp.name] = 1;
        for (var i in this.inputs)
            this.inputs[i].locked = true;
        if (i > 1)
            this.inputs[i].locked = false;
    }

    Concat2.prototype.onInputRemoved = function (slot, name)
    {
        if (this.internal[name])
            delete this.internal[name];
        for (var i in this.inputs)
            this.inputs[i].locked = true;
        if (this.inputs.length > 2)
            this.inputs[i].locked = false;
    }

    Concat2.prototype.onAdded = function ()
    {
        for (var i = 0; i < this.labels.length; i++)
            if (this.internal[this.labels.charAt(i)] && this.inputs.length === i)        
                this.addInput("Num", "numarray");
        
            if(this.outputs.length===0) this.addOutput("Out", "numarray");
        this.setDirtyCanvas(true);
    }

    Concat2.prototype.onExecute = function ()
    {
        if (this.inputs[0].type === "numarray") {
                var out = [];
            for (var i = 0; i < this.inputs.length; i++)
            {

                var inp = this.getInputData(i, this.zero);
                for (var j = 0; j < inp.length; j++){
                    out.push(inp[j]);}
            }
        }
        if (this.inputs[0].type === "pointarray") {
            var out = new pointArray();
            for (var i = 0; i < this.inputs.length; i++)
            {
                out.concat(this.getInputData(i, new pointArray()));
            }
        }
        if (this.inputs[0].type === "objectlist") {
            var out = moi.geometryDatabase.createObjectList();
            for (var i = 0; i < this.inputs.length; i++)
            {
                var inp = this.getInputData(i, moi.geometryDatabase.createObjectList());
                for (var j = 0; j < inp.length; j++)
                    out.addObject(inp.item(j));
            }
        }
        this.setOutputData(0, out);
    }

    LiteGraph.registerNodeType("Objects2/Concat2", Concat2);
    
    function trimObj()
    {
        this.addInput("In", "objectlist");
        this.addInput("Cutters", "objectlist");
        this.addOutput("Out", "objectlist");
        this.properties = {};
    }

    trimObj.title = "trimObj";
    trimObj.desc = "trimObj";

    trimObj.prototype.onExecute = function ()
    {
        var inObj = this.getInputData(0, moi.geometryDatabase.createObjectList());
        var cutObj = this.getInputData(1, moi.geometryDatabase.createObjectList());
        var output = moi.geometryDatabase.createObjectList();
        if (inObj.length > 0 && cutObj.length > 0) {
            var trimFac = moi.command.createFactory('trim');
//                                trimFac.setInput(0, cloneCrv);                                
            trimFac.setInput(0, inObj);
            trimFac.setInput(1, cutObj);
            trimFac.generateFragments();
            trimFac.setInput(2, moi.geometryDatabase.createObjectList());
            trimFac.setInput(3, 'remove');
            trimFac.setInput(4, false);
            trimFac.setInput(5, false);
            trimFac.setInput(6, moi.geometryDatabase.createObjectList());
            output = trimFac.calculate();
            trimFac.cancel();
        }
        this.setOutputData(0, output);
    }

    LiteGraph.registerNodeType("Objects2/trim", trimObj);
    
        function intersectObj()
    {
        this.addInput("In", "objectlist");
        this.addOutput("points", "objectlist");
        this.addOutput("curves", "objectlist");
        this.addOutput("faces", "objectlist");
        this.properties = {};
    }

    intersectObj.title = "intersectObj";
    intersectObj.desc = "intersectObj";

    intersectObj.prototype.onExecute = function ()
    {
        var inObj = this.getInputData(0, moi.geometryDatabase.createObjectList());
        var outPts = moi.geometryDatabase.createObjectList();
        var outCrvs = moi.geometryDatabase.createObjectList();
        var outFc = moi.geometryDatabase.createObjectList();
        if (inObj.length > 1) {
        var intObjs = factory('intersect', inObj);
            for(var i=0;i<intObjs.length;i++){
            if(intObjs.item(i).type===6)outPts.addObject(intObjs.item(i));
            if(intObjs.item(i).type===1||intObjs.item(i).type===2)outCrvs.addObject(intObjs.item(i));
            if(intObjs.item(i).type===3||intObjs.item(i).type===4)outFc.addObject(intObjs.item(i));
            }
       }
        
        this.setOutputData(0, outPts);
        this.setOutputData(1, outCrvs);
        this.setOutputData(2, outFc);
    }

    LiteGraph.registerNodeType("Objects2/intersectObj", intersectObj);
    
    function separateObj()
    {
        this.addInput("In", "objectlist");
        this.addOutput("Out", "objectlist");
//        this.addOutput("points", "objectlist");
//        this.addOutput("curves", "objectlist");
//        this.addOutput("faces", "objectlist");
        this.properties = {};
    }

    separateObj.title = "separateObj";
    separateObj.desc = "separateObj";

    separateObj.prototype.onExecute = function ()
    {
        var inObj = this.getInputData(0, moi.geometryDatabase.createObjectList());
        var out = moi.geometryDatabase.createObjectList();
//        var outPts = moi.geometryDatabase.createObjectList();
//        var outCrvs = moi.geometryDatabase.createObjectList();
//        var outFc = moi.geometryDatabase.createObjectList();
        if (inObj.length > 0) {
            out = factory('separate', inObj);
/*        var intObjs = factory('intersect', inObj);
            for(var i=0;i<intObjs;i++){
            if(intObjs.item(i).type===6)outPts.addObject(intObjs.item(i));
            if(intObjs.item(i).type===1||intObjs.item(i).type===2)outCrvs.addObject(intObjs.item(i));
            if(intObjs.item(i).type===3||intObjs.item(i).type===4)outFc.addObject(intObjs.item(i));
            }*/
       }
        
        this.setOutputData(0, out);
    }

    LiteGraph.registerNodeType("Objects2/separateObj", separateObj);
    
     
    
    
    
    
    
       function extractEdges()
    {
        this.size = [60, 20];
        this.addInput("Brep", "objectlist");
        this.addOutput("Out1", "objectlist");
        this.properties = {objName: '',};
        this.internal = {extractedObjNames: [0]};
        this.selectedObjs = moi.geometryDatabase.createObjectList();
        this.namesOK = false;
    }

    extractEdges.title = "ExtractEdges";
    extractEdges.desc = "ExtractEdges";
    extractEdges.prototype.setValue = function (v)
    {
        if (typeof (v) == "string")
            this.properties.objName = v;
        this.properties.objName = v;
        this.setDirtyCanvas(true);
    }
    
    extractEdges.prototype.getExtraMenuOptions = function() {var that = this, thatgraph = this.graph;  return [{content:lang.getTranslation("Update"), callback: function() { that.onUpdate();thatgraph.setisChangedFlag(that.id);}}];};

     extractEdges.prototype.onUpdate = function () //reselection of the faces for the bridge
     {
     this.internal.extractedObjNames=[0];
     this.onAdded();
     this.onExecute();
     }
    extractEdges.prototype.onPropertyChange = function ()
    {

    }
    extractEdges.prototype.onAdded = function ()
    {
        this.selectedObjs = moi.geometryDatabase.createObjectList();
        this.selectedObjs = moi.geometryDatabase.getSelectedObjects(); // stores the selected faces (2 Faces as start and end of the loft)
        if (this.selectedObjs.length > 0)
        {
            for (var i = 0; i < this.selectedObjs.length; i++)
            {
                if (this.selectedObjs.item(i).name !== '')
                {
                    this.internal.extractedObjNames.push(this.selectedObjs.item(i).name); //storing the names of the selected objects
                    this.namesOK = true;
                } else
                {
                    this.namesOK = false;
                    return this.namesOK;
                }
            }
        }
//                moi.UI.alert(this.properties.filletEdgeNames.length, "selected filletedges");
    }

    extractEdges.prototype.onApply = function ()
    {

    }

    extractEdges.prototype.onExecute = function ()
    {
        var input = moi.geometryDatabase.createObjectList();
        input = this.getInputData(0, moi.geometryDatabase.createObjectList());
        var tempList = moi.geometryDatabase.createObjectList();
//                    moi.UI.alert(this.internal.extractedObjNames.length, "names length");
        if (input.length > 0)
        {
            for (var i = 0; i < this.internal.extractedObjNames.length; i++)
            {
                for (var j = 0; j < input.length; j++)
                {   var brepEdges = input.item(j).getEdges();
  //                  var brepFaces = input.item(j).getFaces();
                        for (var k = 0; k < brepEdges.length; k++){
                           if (brepEdges.item(k).name == this.internal.extractedObjNames[i])
                           tempList.addObject(brepEdges.item(k));   
                        }
//                        for (var l = 0; l < brepFaces.length; l++){
//                           if (brepFaces.item(l).name == this.internal.extractedObjNames[i])
//                          tempList.addObject(brepFaces.item(l));   
//                       }
                }
            }
        }

        var originXYZ = moi.VectorMath.createPoint(0, 0, 0); //Helppoint for a identical copy
        var out=factory('copy',tempList,originXYZ,originXYZ,true);
        this.setOutputData(0, out);
    }

    extractEdges.prototype.onApply = function ()
    {

    }

    extractEdges.prototype.onDrawBackground = function (ctx)
    {
//        this.inputs[0].label = this.properties.edge0;
//        this.inputs[1].label = this.properties.radius;
    }
    LiteGraph.registerNodeType("Objects2/ExtractEdges", extractEdges); 
    
    
    
    
})();